%module SyFi

%feature("autodoc", "1");


%{
#include "../SyFi.h"
#include <ginac/ginac.h>

using namespace GiNaC;
using namespace SyFi;
%}



// utility function:
%{
void setDigits (int a)
{
  Digits = a;
}
%}

void setDigits (int a);



%include cpp2py_exceptions.i

namespace GiNaC {


#define GINACLIB_MAJOR_VERSION 1
#define GINACLIB_MINOR_VERSION 6
#define GINACLIB_MICRO_VERSION 1

//#define GINACLIB_MINOR_VERSION 4
#if GINACLIB_MINOR_VERSION == 6
%include ex.1.5.i
%include typemaps.1.5.i
#elif GINACLIB_MINOR_VERSION == 5
%include ex.1.5.i
%include typemaps.1.5.i
#elif GINACLIB_MINOR_VERSION == 4
%include ex.1.4.i
%include typemaps.1.4.i
#else
%include ex.1.3.i 
%include typemaps.1.3.i
#endif 
}


// typedefs and template instantiations for stl containers with ginac objects

%include stl.i

%include std_string.i
%include std_pair.i
%include std_list.i
%include std_vector.i
%include std_set.i
%include std_map.i


%typedef             std::vector<GiNaC::ex> GiNaC::exvector;
%template(exvector)  std::vector<GiNaC::ex>;

%typedef             std::map<GiNaC::ex, GiNaC::ex, GiNaC::ex_is_less> GiNaC::exmap;
%template(exmap)     std::map<GiNaC::ex, GiNaC::ex, GiNaC::ex_is_less>;

%typedef              std::map<GiNaC::ex, int, GiNaC::ex_is_less> ex_int_map;
%template(ex_int_map) std::map<GiNaC::ex, int, GiNaC::ex_is_less>;

%typedef             std::pair<GiNaC::symbol, GiNaC::ex> symexpair;
%template(symexpair) std::pair<GiNaC::symbol, GiNaC::ex>;

%typedef             std::list< std::pair<GiNaC::symbol, GiNaC::ex> > symexlist;
%template(symexlist) std::list< std::pair<GiNaC::symbol, GiNaC::ex> >;

%typedef             std::list<GiNaC::ex> exlist;
%template(exlist)    std::list<GiNaC::ex>;

%typedef             std::set<GiNaC::ex, GiNaC::ex_is_less> exset;
%template(exset)     std::set<GiNaC::ex, GiNaC::ex_is_less>;



%include syfi_version.h
%include tools.h
%include containers.h
%include utilities.h
%include diff_tools.h
%include ginac_tools.h
%include symbol_factory.h

%include Polygon.h
%include FE.h
%include Lagrange.h
%include Dof.h
%include CrouzeixRaviart.h
%include P0.h
%include RaviartThomas.h
%include DiscontinuousLagrange.h
%include Hermite.h
%include Nedelec.h
%include Nedelec2Hdiv.h
%include Bubble.h
%include ElementComputations.h
%include ArnoldFalkWintherWeakSym.h
%include Robust.h
%include MixedFE.h
%include SpaceTimeElement.h



/*
namespace GiNaC{
  class exvector{};
  class lst{};
}
*/


/*
%extend GiNaC::lst{
  void append(GiNaC::ex& e) {
    self->append(e);
  }
  GiNaC::ex __getitem__(int i) {
    if ( i >= 0 && unsigned(i) <= (*self).nops()-1) {
       return (*self)[i];
    } else {
//       cout << "Outside range of lst!\n";
       return DUMMY;
    }
  }
};


%extend GiNaC::exvector {
  void append(GiNaC::ex& e) {
    self->insert(self->end(), e);
  }
  GiNaC::ex __getitem__(int i) {
    if ( i >= 0 && unsigned(i) <= (*self).size()-1) {
       return (*self)[i];
    } else {
//       cout << "Outside range of exvector!\n";
       return DUMMY;
    }
  }
};
*/

//%pythoncode %{
//from pytools import *
//%}



